/*
 Licensed to the Apache Software Foundation (ASF) under one
 or more contributor license agreements. See the NOTICE file
 distributed with this work for additional information
 regarding copyright ownership. The ASF licenses this file
 to you under the Apache License, Version 2.0 (the
 "License"); you may not use this file except in compliance
 with the License. You may obtain a copy of the License at
 
 http://www.apache.org/licenses/LICENSE-2.0
 
 Unless required by applicable law or agreed to in writing,
 software distributed under the License is distributed on an
 "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 KIND, either express or implied. See the License for the
 specific language governing permissions and limitations
 under the License.
 */

#import <Foundation/Foundation.h>
#import <Cordova/CDVPlugin.h>

// TODO This means that you can start a download of a large image or file, close the app and
// the download wilcontinue until it completes.
@interface BackgroundDownload : CDVPlugin <NSURLSessionDownloadDelegate>

@property (nonatomic) NSURLSession *session;

- (void)startAsync:(CDVInvokedUrlCommand*)command;
- (void)stop:(CDVInvokedUrlCommand*)command;

@end

@interface Download : NSObject

@property NSString *error;
@property NSString *filePath;
@property NSString *uriString;
@property NSString *uriMatcher;
@property NSString *callbackId;
@property (nonatomic) NSURLSessionDownloadTask *task;

- (id) initWithPath:(NSString *)filePath uri:(NSString *)uri uriMatcher:(NSString *)uriMatcher callbackId:(NSString *)callbackId task:(NSURLSessionDownloadTask *)task;

@end
